


<script>

/*
	step 1, create the move:
		{
			"flavor": "ECC_448_2:3043300506032b6571033a00e701f06c74f2990640fbbb062b7e1d0d33c2ea2724f9fdd908cacf0f200270907a8400bd26b287335570f34fca7b0ecd07b0d9622d5ce82a80",
			
		   "scene #": "1",
		   
			#
			#  The play # of the player that is making the proposal
			#
			"flavor move #": "1",
			
			"move": "send escrow",
  
			"return after scene": "1001",
			"amount": "1,0000,0000",
			"fee": "1000",

			
			"sender": "ECC_448_2:3043300506032b6571033a00e701f06c74f2990640fbbb062b7e1d0d33c2ea2724f9fdd908cacf0f200270907a8400bd26b287335570f34fca7b0ecd07b0d9622d5ce82a80",
			
			
			"receiver": "ECC_448_2:3043300506032b6571033a002627190e2111390b66eb971ba50869ce07cd8d316dc52617d1eca9a1b48c7ce9fd72bdd756a668da03982ce9ba917f4333dc22b69ef2af2480"
		}


	step 2, perform the move:
		{
			"story": {
				"flavor": "ECC_448_2:3043300506032b6571033a00e701f06c74f2990640fbbb062b7e1d0d33c2ea2724f9fdd908cacf0f200270907a8400bd26b287335570f34fca7b0ecd07b0d9622d5ce82a80",
				
			   "scene #": "1",
			   
				#
				#  The play # of the player that is making the proposal
				#
				"flavor move #": "1"
			},
			"performance": "",
		}
		
	step 2, vote:
		{
			"move": {
				"story": {
					"scene #": "1",
				   
					#
					#  The play # of the player that is making the proposal
					#
					"play #": "1"
				},
				"performance": "",
			},
			"votes": {
				"923..371": {
					"feeling": "euphoria",
					
					#
					#  The performance of the move
					#
					"performance": ""
				},
				"": {
					"feeling": "euphoria",
					"performance": ""
				}
			}
		}
		
	step 3, order:
		{
			"moves": 			
		}
		
		

	{
		"proposal": {
			"move": {
				"story": {
					"scene #": "1",
				   
					#
					#  The play # of the player that is making the proposal
					#
					"play #": "1"
				},
				"performance": "",
			},
			"votes": {
				"923..371": {
					"feeling": "euphoria",
					
					#
					#  The performance of the move
					#
					"performance": ""
				},
				"": {
					"feeling": "euphoria",
					"performance": ""
				}
			},
			
			#
			#  This is decided by the "scene director"
			#
			"move #": "1"
		},
		"votes": {
			"923..371": {
				"feeling": "euphoria",
				
				#
				#  The performance of the proposal
				#
				"performance": ""
			}
		}
	}
*/


/*
	bwip-js
*/

import bwipjs from 'bwip-js';

import scrolly from '@/components/scrolly/futon.vue'

import { lap } from '@/fleet/lap'

export default {
	components: {
		scrolly	
	},
	
	data () {
		return {
			/*
				azteccode
			*/
			barcode: [ 'azteccode', 'Aztec Code' ],
			barcode_options: [
				[ 'qrcode', 'QR Code' ],
				[ 'azteccode', 'Aztec Code' ]
			],
			
			/*
				
			*/
			render_kind: 'SVG',
			render_options: [
				'canvas',
				'SVG'
			],
			
			/*
				
			*/
			text: ''
		}
	},
	
	computed: {
		bcid () {
			return this.barcode [0]
		}
	},
	
	methods: {
		make_SVG_barcode () {
			const text = this.text;
			const bcid = this.bcid;
			
			const SVG = bwipjs.toSVG ({
				bcid,
				text,
				
				// height: 12,
				
				//includetext: true,
				//textxalign: 'center',

				barcolor: '000000', 
				bordercolor: 'ffffff',
				textcolor: 'ffffff' 
			});
			
			const span = this.$refs ["svg-crate"];
			
			/*
			let [ , width, height ] = /viewBox="0 0 (\d+) (\d+)"/.exec(SVG);
			// let span = document.createElement ('span');
			span.style.display = 'inline-block';
			span.style.width = width + 'px';
			span.style.height = height + 'px';
			span.innerHTML = SVG;
			// document.body.addChild (span);
			*/
			
			this.$refs ["svg-crate"].innerHTML = SVG;
		},
		
		make_canvas_barcode () {
			const canvas = this.$refs.canvas;
			const text = this.text;
			
			/*
				
			*/
			bwipjs.toCanvas (canvas, {
				bcid: this.bcid,
				
				text,
				height: 12,
				
				includetext: true,
				textxalign: 'center',

				barcolor: 'ffffff', 
				bordercolor: 'ffffff',
				textcolor: 'ffffff' 
			});
		},
		
		make_barcode () {
			if (this.render_kind === "canvas") {
				this.make_canvas_barcode ()
			}
			else if (this.render_kind === "SVG") {
				this.make_SVG_barcode ()			
			}
		}
		
	},
	
	mount () {
		
	}
}

</script>

<template>
	<div
		:style="{
			position: 'relative',
			borderRadius: '8px',
			height: '100%'
		}"
	>
		<div
			:style="{
				position: 'absolute',
				height: '100%',
				width: '100%',
				top: 0,
				left: 0,
				
				overflowY: 'scroll',
				
				display: 'flex',
			}"
		>
			<div
				:style="{
					position: 'relative',
					
					width: '20%',
					border: '2px solid white',
					borderRadius: '8px',
					
					boxSizing: 'border-box',
					padding: '20px',
					
					display: 'flex',
					flexDirection: 'column'
				}"
			>
				<div>
					<h1>barcodes</h1>
					
					<div :style="{ height: '20px' }" />
					
					<label>render kind</label>
					<select v-model="render_kind">
						<option 
							v-for="option in render_options" 
							:value="option"
						>{{ option }}</option>
					</select>
					
					<div :style="{ height: '20px' }" />
					
					<label>barcode kind</label>
					<select v-model="barcode">
						<option 
							v-for="option in barcode_options" 
							:value="option"
						>{{ option [1] }}</option>
					</select>
				</div>
			</div>
			
			<div
				:style="{
					width: '20px'
				}"
			/>
			
			<scrolly
				:style="{
					position: 'relative',
					boxSizing: 'border-box',
					
					padding: '20px',
					width: '100%',
					border: '2px solid white',
					background: 'linear-gradient(22deg, #4d1eb540, #282020)',
						
					borderRadius: '8px',
				}"
			>
				<div
					:style="{
						position: 'relative',
						boxSizing: 'border-box',
						
						padding: '20px',
						width: '100%',
						
						textAlign: 'right'
					}"
				>
					<div
						:style="{
							width: '100%',
							textAlign: 'center'
						}"
					>
						<textarea 
							v-model="text"
							:style="{
								position: 'relative',
								boxSizing: 'border-box',
								
								height: '350px',
								width: '100%',
								
								border: '2px solid white',
								borderRadius: '4px',
								
								background: 'transparent',
								
								boxSizing: 'border-box',
								padding: '8px',
								
								fontSize: '1.2em',
								color: 'white'
							}"
						/>
					
						<div :style="{ height: '20px' }" />
					
						<div
							:style="{
								boxSizing: 'border-box',
								border: '2px solid #ffffff2e',
								borderRadius: '8px',
								
								height: '350px',
								width: '350px',
								padding: '10px',
								
								background: 'white'
							}"
						>
							<div 
								v-if="render_kind === 'SVG'"
								ref="svg-crate" 
								:style="{
									boxSizing: 'border-box',
									border: '2px solid #ffffff2e',
									borderRadius: '8px',
									
									height: '100%',
									width: '100%'
								}"
							/>
						</div>
					
						<canvas 
							v-if="render_kind === 'canvas'"
							ref="canvas"
							:style="{
								boxSizing: 'border-box',
								border: '2px solid #ffffff2e',
								borderRadius: '8px',
								
								height: '350px',
								width: '350px',
								padding: '10px'
							}"
						/>
					</div>
				
					<div :style="{ height: '20px' }" />
				
					<VaButton
						color="#FFF"
						@click="make_barcode"
					>Generate {{ barcode [1] }}</VaButton>
				</div>
			</scrolly>
		</div>
	</div>
</template>
